"""
This module is home to the DemandResponse class
"""
from pyecobee.ecobee_object import EcobeeObject


class DemandResponse(EcobeeObject):
    """
    This class has been auto generated by scraping
    https://www.ecobee.com/home/developer/api/documentation/v1/objects/DemandResponse.shtml

    Attribute names have been generated by converting ecobee property names from camelCase to snake_case.

    A getter property has been generated for each attribute.
    A setter property has been generated for each attribute whose value of READONLY is "no".

    An __init__ argument without a default value has been generated if the value of REQUIRED is "yes".
    An __init__ argument with a default value of None has been generated if the value of REQUIRED is "no".
   """
    __slots__ = ['_name', '_demand_response_ref', '_comments', '_message', '_deferred_date', '_deferred_time',
                 '_show_idt', '_show_web', '_send_email', '_randomize_start_time', '_random_start_time_seconds',
                 '_randomize_end_time', '_random_end_time_seconds', '_event', '_thermostats', '_external_ref',
                 '_external_ref_type', '_priority']

    attribute_name_map = {'name': 'name', 'demand_response_ref': 'demandResponseRef',
                          'demandResponseRef': 'demand_response_ref', 'comments': 'comments', 'message': 'message',
                          'deferred_date': 'deferredDate', 'deferredDate': 'deferred_date',
                          'deferred_time': 'deferredTime', 'deferredTime': 'deferred_time', 'show_idt': 'showIdt',
                          'showIdt': 'show_idt', 'show_web': 'showWeb', 'showWeb': 'show_web',
                          'send_email': 'sendEmail', 'sendEmail': 'send_email',
                          'randomize_start_time': 'randomizeStartTime', 'randomizeStartTime': 'randomize_start_time',
                          'random_start_time_seconds': 'randomStartTimeSeconds',
                          'randomStartTimeSeconds': 'random_start_time_seconds',
                          'randomize_end_time': 'randomizeEndTime', 'randomizeEndTime': 'randomize_end_time',
                          'random_end_time_seconds': 'randomEndTimeSeconds',
                          'randomEndTimeSeconds': 'random_end_time_seconds', 'event': 'event',
                          'thermostats': 'thermostats', 'external_ref': 'externalRef', 'externalRef': 'external_ref',
                          'external_ref_type': 'externalRefType', 'externalRefType': 'external_ref_type',
                          'priority': 'priority'}

    attribute_type_map = {'name': 'six.text_type', 'demand_response_ref': 'six.text_type', 'comments': 'six.text_type',
                          'message': 'six.text_type', 'deferred_date': 'six.text_type',
                          'deferred_time': 'six.text_type', 'show_idt': 'bool', 'show_web': 'bool',
                          'send_email': 'bool', 'randomize_start_time': 'bool', 'random_start_time_seconds': 'int',
                          'randomize_end_time': 'bool', 'random_end_time_seconds': 'int', 'event': 'Event',
                          'thermostats': 'List[six.text_type]', 'external_ref': 'six.text_type',
                          'external_ref_type': 'six.text_type', 'priority': 'Long'}

    def __init__(self, name=None, demand_response_ref=None, comments=None, message=None, deferred_date=None,
                 deferred_time=None, show_idt=None, show_web=None, send_email=None, randomize_start_time=None,
                 random_start_time_seconds=None, randomize_end_time=None, random_end_time_seconds=None, event=None,
                 thermostats=None, external_ref=None, external_ref_type=None, priority=None):
        """
        Construct a DemandResponse instance
        """
        self._name = name
        self._demand_response_ref = demand_response_ref
        self._comments = comments
        self._message = message
        self._deferred_date = deferred_date
        self._deferred_time = deferred_time
        self._show_idt = show_idt
        self._show_web = show_web
        self._send_email = send_email
        self._randomize_start_time = randomize_start_time
        self._random_start_time_seconds = random_start_time_seconds
        self._randomize_end_time = randomize_end_time
        self._random_end_time_seconds = random_end_time_seconds
        self._event = event
        self._thermostats = thermostats
        self._external_ref = external_ref
        self._external_ref_type = external_ref_type
        self._priority = priority

    @property
    def name(self):
        """
        Gets the name attribute of this DemandResponse instance.

        :return: The value of the name attribute of this DemandResponse instance.
        :rtype: six.text_type
        """

        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name attribute of this DemandResponse instance.

        :param name: The name value to set for the name attribute of this DemandResponse instance.
        :type: six.text_type
        """

        self._name = name

    @property
    def demand_response_ref(self):
        """
        Gets the demand_response_ref attribute of this DemandResponse instance.

        :return: The value of the demand_response_ref attribute of this DemandResponse instance.
        :rtype: six.text_type
        """

        return self._demand_response_ref

    @property
    def comments(self):
        """
        Gets the comments attribute of this DemandResponse instance.

        :return: The value of the comments attribute of this DemandResponse instance.
        :rtype: six.text_type
        """

        return self._comments

    @comments.setter
    def comments(self, comments):
        """
        Sets the comments attribute of this DemandResponse instance.

        :param comments: The comments value to set for the comments attribute of this DemandResponse instance.
        :type: six.text_type
        """

        self._comments = comments

    @property
    def message(self):
        """
        Gets the message attribute of this DemandResponse instance.

        :return: The value of the message attribute of this DemandResponse instance.
        :rtype: six.text_type
        """

        return self._message

    @message.setter
    def message(self, message):
        """
        Sets the message attribute of this DemandResponse instance.

        :param message: The message value to set for the message attribute of this DemandResponse instance.
        :type: six.text_type
        """

        self._message = message

    @property
    def deferred_date(self):
        """
        Gets the deferred_date attribute of this DemandResponse instance.

        :return: The value of the deferred_date attribute of this DemandResponse instance.
        :rtype: six.text_type
        """

        return self._deferred_date

    @deferred_date.setter
    def deferred_date(self, deferred_date):
        """
        Sets the deferred_date attribute of this DemandResponse instance.

        :param deferred_date: The deferred_date value to set for the deferred_date attribute of this DemandResponse instance.
        :type: six.text_type
        """

        self._deferred_date = deferred_date

    @property
    def deferred_time(self):
        """
        Gets the deferred_time attribute of this DemandResponse instance.

        :return: The value of the deferred_time attribute of this DemandResponse instance.
        :rtype: six.text_type
        """

        return self._deferred_time

    @deferred_time.setter
    def deferred_time(self, deferred_time):
        """
        Sets the deferred_time attribute of this DemandResponse instance.

        :param deferred_time: The deferred_time value to set for the deferred_time attribute of this DemandResponse instance.
        :type: six.text_type
        """

        self._deferred_time = deferred_time

    @property
    def show_idt(self):
        """
        Gets the show_idt attribute of this DemandResponse instance.

        :return: The value of the show_idt attribute of this DemandResponse instance.
        :rtype: bool
        """

        return self._show_idt

    @show_idt.setter
    def show_idt(self, show_idt):
        """
        Sets the show_idt attribute of this DemandResponse instance.

        :param show_idt: The show_idt value to set for the show_idt attribute of this DemandResponse instance.
        :type: bool
        """

        self._show_idt = show_idt

    @property
    def show_web(self):
        """
        Gets the show_web attribute of this DemandResponse instance.

        :return: The value of the show_web attribute of this DemandResponse instance.
        :rtype: bool
        """

        return self._show_web

    @show_web.setter
    def show_web(self, show_web):
        """
        Sets the show_web attribute of this DemandResponse instance.

        :param show_web: The show_web value to set for the show_web attribute of this DemandResponse instance.
        :type: bool
        """

        self._show_web = show_web

    @property
    def send_email(self):
        """
        Gets the send_email attribute of this DemandResponse instance.

        :return: The value of the send_email attribute of this DemandResponse instance.
        :rtype: bool
        """

        return self._send_email

    @send_email.setter
    def send_email(self, send_email):
        """
        Sets the send_email attribute of this DemandResponse instance.

        :param send_email: The send_email value to set for the send_email attribute of this DemandResponse instance.
        :type: bool
        """

        self._send_email = send_email

    @property
    def randomize_start_time(self):
        """
        Gets the randomize_start_time attribute of this DemandResponse instance.

        :return: The value of the randomize_start_time attribute of this DemandResponse instance.
        :rtype: bool
        """

        return self._randomize_start_time

    @randomize_start_time.setter
    def randomize_start_time(self, randomize_start_time):
        """
        Sets the randomize_start_time attribute of this DemandResponse instance.

        :param randomize_start_time: The randomize_start_time value to set for the randomize_start_time attribute of this DemandResponse instance.
        :type: bool
        """

        self._randomize_start_time = randomize_start_time

    @property
    def random_start_time_seconds(self):
        """
        Gets the random_start_time_seconds attribute of this DemandResponse instance.

        :return: The value of the random_start_time_seconds attribute of this DemandResponse instance.
        :rtype: int
        """

        return self._random_start_time_seconds

    @random_start_time_seconds.setter
    def random_start_time_seconds(self, random_start_time_seconds):
        """
        Sets the random_start_time_seconds attribute of this DemandResponse instance.

        :param random_start_time_seconds: The random_start_time_seconds value to set for the random_start_time_seconds attribute of this DemandResponse instance.
        :type: int
        """

        self._random_start_time_seconds = random_start_time_seconds

    @property
    def randomize_end_time(self):
        """
        Gets the randomize_end_time attribute of this DemandResponse instance.

        :return: The value of the randomize_end_time attribute of this DemandResponse instance.
        :rtype: bool
        """

        return self._randomize_end_time

    @randomize_end_time.setter
    def randomize_end_time(self, randomize_end_time):
        """
        Sets the randomize_end_time attribute of this DemandResponse instance.

        :param randomize_end_time: The randomize_end_time value to set for the randomize_end_time attribute of this DemandResponse instance.
        :type: bool
        """

        self._randomize_end_time = randomize_end_time

    @property
    def random_end_time_seconds(self):
        """
        Gets the random_end_time_seconds attribute of this DemandResponse instance.

        :return: The value of the random_end_time_seconds attribute of this DemandResponse instance.
        :rtype: int
        """

        return self._random_end_time_seconds

    @random_end_time_seconds.setter
    def random_end_time_seconds(self, random_end_time_seconds):
        """
        Sets the random_end_time_seconds attribute of this DemandResponse instance.

        :param random_end_time_seconds: The random_end_time_seconds value to set for the random_end_time_seconds attribute of this DemandResponse instance.
        :type: int
        """

        self._random_end_time_seconds = random_end_time_seconds

    @property
    def event(self):
        """
        Gets the event attribute of this DemandResponse instance.

        :return: The value of the event attribute of this DemandResponse instance.
        :rtype: Event
        """

        return self._event

    @event.setter
    def event(self, event):
        """
        Sets the event attribute of this DemandResponse instance.

        :param event: The event value to set for the event attribute of this DemandResponse instance.
        :type: Event
        """

        self._event = event

    @property
    def thermostats(self):
        """
        Gets the thermostats attribute of this DemandResponse instance.

        :return: The value of the thermostats attribute of this DemandResponse instance.
        :rtype: List[six.text_type]
        """

        return self._thermostats

    @property
    def external_ref(self):
        """
        Gets the external_ref attribute of this DemandResponse instance.

        :return: The value of the external_ref attribute of this DemandResponse instance.
        :rtype: six.text_type
        """

        return self._external_ref

    @external_ref.setter
    def external_ref(self, external_ref):
        """
        Sets the external_ref attribute of this DemandResponse instance.

        :param external_ref: The external_ref value to set for the external_ref attribute of this DemandResponse instance.
        :type: six.text_type
        """

        self._external_ref = external_ref

    @property
    def external_ref_type(self):
        """
        Gets the external_ref_type attribute of this DemandResponse instance.

        :return: The value of the external_ref_type attribute of this DemandResponse instance.
        :rtype: six.text_type
        """

        return self._external_ref_type

    @external_ref_type.setter
    def external_ref_type(self, external_ref_type):
        """
        Sets the external_ref_type attribute of this DemandResponse instance.

        :param external_ref_type: The external_ref_type value to set for the external_ref_type attribute of this DemandResponse instance.
        :type: six.text_type
        """

        self._external_ref_type = external_ref_type

    @property
    def priority(self):
        """
        Gets the priority attribute of this DemandResponse instance.

        :return: The value of the priority attribute of this DemandResponse instance.
        :rtype: Long
        """

        return self._priority

    @priority.setter
    def priority(self, priority):
        """
        Sets the priority attribute of this DemandResponse instance.

        :param priority: The priority value to set for the priority attribute of this DemandResponse instance.
        :type: Long
        """

        self._priority = priority
