"""
This module is home to the Group class
"""
from pyecobee.ecobee_object import EcobeeObject


class Group(EcobeeObject):
    """
    This class has been auto generated by scraping
    https://www.ecobee.com/home/developer/api/documentation/v1/objects/Group.shtml

    Attribute names have been generated by converting ecobee property names from camelCase to snake_case.

    A getter property has been generated for each attribute.
    A setter property has been generated for each attribute whose value of READONLY is "no".

    An __init__ argument without a default value has been generated if the value of REQUIRED is "yes".
    An __init__ argument with a default value of None has been generated if the value of REQUIRED is "no".
   """
    __slots__ = ['_group_name', '_group_ref', '_synchronize_alerts', '_synchronize_system_mode',
                 '_synchronize_schedule', '_synchronize_quick_save', '_synchronize_reminders',
                 '_synchronize_contractor_info', '_synchronize_user_preferences', '_synchronize_utility_info',
                 '_synchronize_location', '_synchronize_reset', '_synchronize_vacation', '_thermostats']

    attribute_name_map = {'group_name': 'groupName', 'groupName': 'group_name', 'group_ref': 'groupRef',
                          'groupRef': 'group_ref', 'synchronize_alerts': 'synchronizeAlerts',
                          'synchronizeAlerts': 'synchronize_alerts', 'synchronize_system_mode': 'synchronizeSystemMode',
                          'synchronizeSystemMode': 'synchronize_system_mode',
                          'synchronize_schedule': 'synchronizeSchedule', 'synchronizeSchedule': 'synchronize_schedule',
                          'synchronize_quick_save': 'synchronizeQuickSave',
                          'synchronizeQuickSave': 'synchronize_quick_save',
                          'synchronize_reminders': 'synchronizeReminders',
                          'synchronizeReminders': 'synchronize_reminders',
                          'synchronize_contractor_info': 'synchronizeContractorInfo',
                          'synchronizeContractorInfo': 'synchronize_contractor_info',
                          'synchronize_user_preferences': 'synchronizeUserPreferences',
                          'synchronizeUserPreferences': 'synchronize_user_preferences',
                          'synchronize_utility_info': 'synchronizeUtilityInfo',
                          'synchronizeUtilityInfo': 'synchronize_utility_info',
                          'synchronize_location': 'synchronizeLocation', 'synchronizeLocation': 'synchronize_location',
                          'synchronize_reset': 'synchronizeReset', 'synchronizeReset': 'synchronize_reset',
                          'synchronize_vacation': 'synchronizeVacation', 'synchronizeVacation': 'synchronize_vacation',
                          'thermostats': 'thermostats'}

    attribute_type_map = {'group_name': 'six.text_type', 'group_ref': 'six.text_type', 'synchronize_alerts': 'bool',
                          'synchronize_system_mode': 'bool', 'synchronize_schedule': 'bool',
                          'synchronize_quick_save': 'bool', 'synchronize_reminders': 'bool',
                          'synchronize_contractor_info': 'bool', 'synchronize_user_preferences': 'bool',
                          'synchronize_utility_info': 'bool', 'synchronize_location': 'bool',
                          'synchronize_reset': 'bool', 'synchronize_vacation': 'bool',
                          'thermostats': 'List[six.text_type]'}

    def __init__(self, group_name, group_ref=None, synchronize_alerts=None, synchronize_system_mode=None,
                 synchronize_schedule=None, synchronize_quick_save=None, synchronize_reminders=None,
                 synchronize_contractor_info=None, synchronize_user_preferences=None, synchronize_utility_info=None,
                 synchronize_location=None, synchronize_reset=None, synchronize_vacation=None, thermostats=None):
        """
        Construct a Group instance
        """
        self._group_name = group_name
        self._group_ref = group_ref
        self._synchronize_alerts = synchronize_alerts
        self._synchronize_system_mode = synchronize_system_mode
        self._synchronize_schedule = synchronize_schedule
        self._synchronize_quick_save = synchronize_quick_save
        self._synchronize_reminders = synchronize_reminders
        self._synchronize_contractor_info = synchronize_contractor_info
        self._synchronize_user_preferences = synchronize_user_preferences
        self._synchronize_utility_info = synchronize_utility_info
        self._synchronize_location = synchronize_location
        self._synchronize_reset = synchronize_reset
        self._synchronize_vacation = synchronize_vacation
        self._thermostats = thermostats

    @property
    def group_name(self):
        """
        Gets the group_name attribute of this Group instance.

        :return: The value of the group_name attribute of this Group instance.
        :rtype: six.text_type
        """

        return self._group_name

    @group_name.setter
    def group_name(self, group_name):
        """
        Sets the group_name attribute of this Group instance.

        :param group_name: The group_name value to set for the group_name attribute of this Group instance.
        :type: six.text_type
        """

        self._group_name = group_name

    @property
    def group_ref(self):
        """
        Gets the group_ref attribute of this Group instance.

        :return: The value of the group_ref attribute of this Group instance.
        :rtype: six.text_type
        """

        return self._group_ref

    @property
    def synchronize_alerts(self):
        """
        Gets the synchronize_alerts attribute of this Group instance.

        :return: The value of the synchronize_alerts attribute of this Group instance.
        :rtype: bool
        """

        return self._synchronize_alerts

    @synchronize_alerts.setter
    def synchronize_alerts(self, synchronize_alerts):
        """
        Sets the synchronize_alerts attribute of this Group instance.

        :param synchronize_alerts: The synchronize_alerts value to set for the synchronize_alerts attribute of this Group instance.
        :type: bool
        """

        self._synchronize_alerts = synchronize_alerts

    @property
    def synchronize_system_mode(self):
        """
        Gets the synchronize_system_mode attribute of this Group instance.

        :return: The value of the synchronize_system_mode attribute of this Group instance.
        :rtype: bool
        """

        return self._synchronize_system_mode

    @synchronize_system_mode.setter
    def synchronize_system_mode(self, synchronize_system_mode):
        """
        Sets the synchronize_system_mode attribute of this Group instance.

        :param synchronize_system_mode: The synchronize_system_mode value to set for the synchronize_system_mode attribute of this Group instance.
        :type: bool
        """

        self._synchronize_system_mode = synchronize_system_mode

    @property
    def synchronize_schedule(self):
        """
        Gets the synchronize_schedule attribute of this Group instance.

        :return: The value of the synchronize_schedule attribute of this Group instance.
        :rtype: bool
        """

        return self._synchronize_schedule

    @synchronize_schedule.setter
    def synchronize_schedule(self, synchronize_schedule):
        """
        Sets the synchronize_schedule attribute of this Group instance.

        :param synchronize_schedule: The synchronize_schedule value to set for the synchronize_schedule attribute of this Group instance.
        :type: bool
        """

        self._synchronize_schedule = synchronize_schedule

    @property
    def synchronize_quick_save(self):
        """
        Gets the synchronize_quick_save attribute of this Group instance.

        :return: The value of the synchronize_quick_save attribute of this Group instance.
        :rtype: bool
        """

        return self._synchronize_quick_save

    @synchronize_quick_save.setter
    def synchronize_quick_save(self, synchronize_quick_save):
        """
        Sets the synchronize_quick_save attribute of this Group instance.

        :param synchronize_quick_save: The synchronize_quick_save value to set for the synchronize_quick_save attribute of this Group instance.
        :type: bool
        """

        self._synchronize_quick_save = synchronize_quick_save

    @property
    def synchronize_reminders(self):
        """
        Gets the synchronize_reminders attribute of this Group instance.

        :return: The value of the synchronize_reminders attribute of this Group instance.
        :rtype: bool
        """

        return self._synchronize_reminders

    @synchronize_reminders.setter
    def synchronize_reminders(self, synchronize_reminders):
        """
        Sets the synchronize_reminders attribute of this Group instance.

        :param synchronize_reminders: The synchronize_reminders value to set for the synchronize_reminders attribute of this Group instance.
        :type: bool
        """

        self._synchronize_reminders = synchronize_reminders

    @property
    def synchronize_contractor_info(self):
        """
        Gets the synchronize_contractor_info attribute of this Group instance.

        :return: The value of the synchronize_contractor_info attribute of this Group instance.
        :rtype: bool
        """

        return self._synchronize_contractor_info

    @synchronize_contractor_info.setter
    def synchronize_contractor_info(self, synchronize_contractor_info):
        """
        Sets the synchronize_contractor_info attribute of this Group instance.

        :param synchronize_contractor_info: The synchronize_contractor_info value to set for the synchronize_contractor_info attribute of this Group instance.
        :type: bool
        """

        self._synchronize_contractor_info = synchronize_contractor_info

    @property
    def synchronize_user_preferences(self):
        """
        Gets the synchronize_user_preferences attribute of this Group instance.

        :return: The value of the synchronize_user_preferences attribute of this Group instance.
        :rtype: bool
        """

        return self._synchronize_user_preferences

    @synchronize_user_preferences.setter
    def synchronize_user_preferences(self, synchronize_user_preferences):
        """
        Sets the synchronize_user_preferences attribute of this Group instance.

        :param synchronize_user_preferences: The synchronize_user_preferences value to set for the synchronize_user_preferences attribute of this Group instance.
        :type: bool
        """

        self._synchronize_user_preferences = synchronize_user_preferences

    @property
    def synchronize_utility_info(self):
        """
        Gets the synchronize_utility_info attribute of this Group instance.

        :return: The value of the synchronize_utility_info attribute of this Group instance.
        :rtype: bool
        """

        return self._synchronize_utility_info

    @synchronize_utility_info.setter
    def synchronize_utility_info(self, synchronize_utility_info):
        """
        Sets the synchronize_utility_info attribute of this Group instance.

        :param synchronize_utility_info: The synchronize_utility_info value to set for the synchronize_utility_info attribute of this Group instance.
        :type: bool
        """

        self._synchronize_utility_info = synchronize_utility_info

    @property
    def synchronize_location(self):
        """
        Gets the synchronize_location attribute of this Group instance.

        :return: The value of the synchronize_location attribute of this Group instance.
        :rtype: bool
        """

        return self._synchronize_location

    @synchronize_location.setter
    def synchronize_location(self, synchronize_location):
        """
        Sets the synchronize_location attribute of this Group instance.

        :param synchronize_location: The synchronize_location value to set for the synchronize_location attribute of this Group instance.
        :type: bool
        """

        self._synchronize_location = synchronize_location

    @property
    def synchronize_reset(self):
        """
        Gets the synchronize_reset attribute of this Group instance.

        :return: The value of the synchronize_reset attribute of this Group instance.
        :rtype: bool
        """

        return self._synchronize_reset

    @synchronize_reset.setter
    def synchronize_reset(self, synchronize_reset):
        """
        Sets the synchronize_reset attribute of this Group instance.

        :param synchronize_reset: The synchronize_reset value to set for the synchronize_reset attribute of this Group instance.
        :type: bool
        """

        self._synchronize_reset = synchronize_reset

    @property
    def synchronize_vacation(self):
        """
        Gets the synchronize_vacation attribute of this Group instance.

        :return: The value of the synchronize_vacation attribute of this Group instance.
        :rtype: bool
        """

        return self._synchronize_vacation

    @synchronize_vacation.setter
    def synchronize_vacation(self, synchronize_vacation):
        """
        Sets the synchronize_vacation attribute of this Group instance.

        :param synchronize_vacation: The synchronize_vacation value to set for the synchronize_vacation attribute of this Group instance.
        :type: bool
        """

        self._synchronize_vacation = synchronize_vacation

    @property
    def thermostats(self):
        """
        Gets the thermostats attribute of this Group instance.

        :return: The value of the thermostats attribute of this Group instance.
        :rtype: List[six.text_type]
        """

        return self._thermostats

    @thermostats.setter
    def thermostats(self, thermostats):
        """
        Sets the thermostats attribute of this Group instance.

        :param thermostats: The thermostats value to set for the thermostats attribute of this Group instance.
        :type: List[six.text_type]
        """

        self._thermostats = thermostats
