"""
This module is home to the HierarchyUser class
"""
from pyecobee.ecobee_object import EcobeeObject


class HierarchyUser(EcobeeObject):
    """
    This class has been auto generated by scraping
    https://www.ecobee.com/home/developer/api/documentation/v1/objects/HierarchyUser.shtml

    Attribute names have been generated by converting ecobee property names from camelCase to snake_case.

    A getter property has been generated for each attribute.
    A setter property has been generated for each attribute whose value of READONLY is "no".

    An __init__ argument without a default value has been generated if the value of REQUIRED is "yes".
    An __init__ argument with a default value of None has been generated if the value of REQUIRED is "no".
   """
    __slots__ = ['_user_name', '_first_name', '_last_name', '_phone', '_last_login', '_active', '_email_alerts']

    attribute_name_map = {'user_name': 'userName', 'userName': 'user_name', 'first_name': 'firstName',
                          'firstName': 'first_name', 'last_name': 'lastName', 'lastName': 'last_name', 'phone': 'phone',
                          'last_login': 'lastLogin', 'lastLogin': 'last_login', 'active': 'active',
                          'email_alerts': 'emailAlerts', 'emailAlerts': 'email_alerts'}

    attribute_type_map = {'user_name': 'six.text_type', 'first_name': 'six.text_type', 'last_name': 'six.text_type',
                          'phone': 'six.text_type', 'last_login': 'six.text_type', 'active': 'bool',
                          'email_alerts': 'bool'}

    def __init__(self, user_name, first_name=None, last_name=None, phone=None, last_login=None, active=None,
                 email_alerts=None):
        """
        Construct a HierarchyUser instance
        """
        self._user_name = user_name
        self._first_name = first_name
        self._last_name = last_name
        self._phone = phone
        self._last_login = last_login
        self._active = active
        self._email_alerts = email_alerts

    @property
    def user_name(self):
        """
        Gets the user_name attribute of this HierarchyUser instance.

        :return: The value of the user_name attribute of this HierarchyUser instance.
        :rtype: six.text_type
        """

        return self._user_name

    @user_name.setter
    def user_name(self, user_name):
        """
        Sets the user_name attribute of this HierarchyUser instance.

        :param user_name: The user_name value to set for the user_name attribute of this HierarchyUser instance.
        :type: six.text_type
        """

        self._user_name = user_name

    @property
    def first_name(self):
        """
        Gets the first_name attribute of this HierarchyUser instance.

        :return: The value of the first_name attribute of this HierarchyUser instance.
        :rtype: six.text_type
        """

        return self._first_name

    @first_name.setter
    def first_name(self, first_name):
        """
        Sets the first_name attribute of this HierarchyUser instance.

        :param first_name: The first_name value to set for the first_name attribute of this HierarchyUser instance.
        :type: six.text_type
        """

        self._first_name = first_name

    @property
    def last_name(self):
        """
        Gets the last_name attribute of this HierarchyUser instance.

        :return: The value of the last_name attribute of this HierarchyUser instance.
        :rtype: six.text_type
        """

        return self._last_name

    @last_name.setter
    def last_name(self, last_name):
        """
        Sets the last_name attribute of this HierarchyUser instance.

        :param last_name: The last_name value to set for the last_name attribute of this HierarchyUser instance.
        :type: six.text_type
        """

        self._last_name = last_name

    @property
    def phone(self):
        """
        Gets the phone attribute of this HierarchyUser instance.

        :return: The value of the phone attribute of this HierarchyUser instance.
        :rtype: six.text_type
        """

        return self._phone

    @phone.setter
    def phone(self, phone):
        """
        Sets the phone attribute of this HierarchyUser instance.

        :param phone: The phone value to set for the phone attribute of this HierarchyUser instance.
        :type: six.text_type
        """

        self._phone = phone

    @property
    def last_login(self):
        """
        Gets the last_login attribute of this HierarchyUser instance.

        :return: The value of the last_login attribute of this HierarchyUser instance.
        :rtype: six.text_type
        """

        return self._last_login

    @property
    def active(self):
        """
        Gets the active attribute of this HierarchyUser instance.

        :return: The value of the active attribute of this HierarchyUser instance.
        :rtype: bool
        """

        return self._active

    @active.setter
    def active(self, active):
        """
        Sets the active attribute of this HierarchyUser instance.

        :param active: The active value to set for the active attribute of this HierarchyUser instance.
        :type: bool
        """

        self._active = active

    @property
    def email_alerts(self):
        """
        Gets the email_alerts attribute of this HierarchyUser instance.

        :return: The value of the email_alerts attribute of this HierarchyUser instance.
        :rtype: bool
        """

        return self._email_alerts

    @email_alerts.setter
    def email_alerts(self, email_alerts):
        """
        Sets the email_alerts attribute of this HierarchyUser instance.

        :param email_alerts: The email_alerts value to set for the email_alerts attribute of this HierarchyUser instance.
        :type: bool
        """

        self._email_alerts = email_alerts
