"""
This module is home to the MeterReport class
"""
from pyecobee.ecobee_object import EcobeeObject


class MeterReport(EcobeeObject):
    """
    This class has been auto generated by scraping
    https://www.ecobee.com/home/developer/api/documentation/v1/objects/MeterReport.shtml

    Attribute names have been generated by converting ecobee property names from camelCase to snake_case.

    A getter property has been generated for each attribute.
    A setter property has been generated for each attribute whose value of READONLY is "no".

    An __init__ argument without a default value has been generated if the value of REQUIRED is "yes".
    An __init__ argument with a default value of None has been generated if the value of REQUIRED is "no".
   """
    __slots__ = ['_thermostat_identifier', '_meter_list']

    attribute_name_map = {'thermostat_identifier': 'thermostatIdentifier',
                          'thermostatIdentifier': 'thermostat_identifier', 'meter_list': 'meterList',
                          'meterList': 'meter_list'}

    attribute_type_map = {'thermostat_identifier': 'six.text_type', 'meter_list': 'List[MeterReportData]'}

    def __init__(self, thermostat_identifier=None, meter_list=None):
        """
        Construct a MeterReport instance
        """
        self._thermostat_identifier = thermostat_identifier
        self._meter_list = meter_list

    @property
    def thermostat_identifier(self):
        """
        Gets the thermostat_identifier attribute of this MeterReport instance.

        :return: The value of the thermostat_identifier attribute of this MeterReport instance.
        :rtype: six.text_type
        """

        return self._thermostat_identifier

    @property
    def meter_list(self):
        """
        Gets the meter_list attribute of this MeterReport instance.

        :return: The value of the meter_list attribute of this MeterReport instance.
        :rtype: List[MeterReportData]
        """

        return self._meter_list
