"""
This module is home to the Page class
"""
from pyecobee.ecobee_object import EcobeeObject


class Page(EcobeeObject):
    """
    This class has been auto generated by scraping
    https://www.ecobee.com/home/developer/api/documentation/v1/objects/Page.shtml

    Attribute names have been generated by converting ecobee property names from camelCase to snake_case.

    A getter property has been generated for each attribute.
    A setter property has been generated for each attribute whose value of READONLY is "no".

    An __init__ argument without a default value has been generated if the value of REQUIRED is "yes".
    An __init__ argument with a default value of None has been generated if the value of REQUIRED is "no".
   """
    __slots__ = ['_page', '_total_pages', '_page_size', '_total']

    attribute_name_map = {'page': 'page', 'total_pages': 'totalPages', 'totalPages': 'total_pages',
                          'page_size': 'pageSize', 'pageSize': 'page_size', 'total': 'total'}

    attribute_type_map = {'page': 'int', 'total_pages': 'int', 'page_size': 'int', 'total': 'int'}

    def __init__(self, page=None, total_pages=None, page_size=None, total=None):
        """
        Construct a Page instance
        """
        self._page = page
        self._total_pages = total_pages
        self._page_size = page_size
        self._total = total

    @property
    def page(self):
        """
        Gets the page attribute of this Page instance.

        :return: The value of the page attribute of this Page instance.
        :rtype: int
        """

        return self._page

    @property
    def total_pages(self):
        """
        Gets the total_pages attribute of this Page instance.

        :return: The value of the total_pages attribute of this Page instance.
        :rtype: int
        """

        return self._total_pages

    @property
    def page_size(self):
        """
        Gets the page_size attribute of this Page instance.

        :return: The value of the page_size attribute of this Page instance.
        :rtype: int
        """

        return self._page_size

    @property
    def total(self):
        """
        Gets the total attribute of this Page instance.

        :return: The value of the total attribute of this Page instance.
        :rtype: int
        """

        return self._total
