"""
This module is home to the RuntimeSensorMetadata class
"""
from pyecobee.ecobee_object import EcobeeObject


class RuntimeSensorMetadata(EcobeeObject):
    """
    This class has been auto generated by scraping
    https://www.ecobee.com/home/developer/api/documentation/v1/objects/RuntimeSensorMetadata.shtml

    Attribute names have been generated by converting ecobee property names from camelCase to snake_case.

    A getter property has been generated for each attribute.
    A setter property has been generated for each attribute whose value of READONLY is "no".

    An __init__ argument without a default value has been generated if the value of REQUIRED is "yes".
    An __init__ argument with a default value of None has been generated if the value of REQUIRED is "no".
   """
    __slots__ = ['_sensor_id', '_sensor_name', '_sensor_type', '_sensor_usage']

    attribute_name_map = {'sensor_id': 'sensorId', 'sensorId': 'sensor_id', 'sensor_name': 'sensorName',
                          'sensorName': 'sensor_name', 'sensor_type': 'sensorType', 'sensorType': 'sensor_type',
                          'sensor_usage': 'sensorUsage', 'sensorUsage': 'sensor_usage'}

    attribute_type_map = {'sensor_id': 'six.text_type', 'sensor_name': 'six.text_type', 'sensor_type': 'six.text_type',
                          'sensor_usage': 'six.text_type'}

    def __init__(self, sensor_id=None, sensor_name=None, sensor_type=None, sensor_usage=None):
        """
        Construct a RuntimeSensorMetadata instance
        """
        self._sensor_id = sensor_id
        self._sensor_name = sensor_name
        self._sensor_type = sensor_type
        self._sensor_usage = sensor_usage

    @property
    def sensor_id(self):
        """
        Gets the sensor_id attribute of this RuntimeSensorMetadata instance.

        :return: The value of the sensor_id attribute of this RuntimeSensorMetadata instance.
        :rtype: six.text_type
        """

        return self._sensor_id

    @property
    def sensor_name(self):
        """
        Gets the sensor_name attribute of this RuntimeSensorMetadata instance.

        :return: The value of the sensor_name attribute of this RuntimeSensorMetadata instance.
        :rtype: six.text_type
        """

        return self._sensor_name

    @property
    def sensor_type(self):
        """
        Gets the sensor_type attribute of this RuntimeSensorMetadata instance.

        :return: The value of the sensor_type attribute of this RuntimeSensorMetadata instance.
        :rtype: six.text_type
        """

        return self._sensor_type

    @property
    def sensor_usage(self):
        """
        Gets the sensor_usage attribute of this RuntimeSensorMetadata instance.

        :return: The value of the sensor_usage attribute of this RuntimeSensorMetadata instance.
        :rtype: six.text_type
        """

        return self._sensor_usage
