"""
This module is home to the Weather class
"""
from pyecobee.ecobee_object import EcobeeObject


class Weather(EcobeeObject):
    """
    This class has been auto generated by scraping
    https://www.ecobee.com/home/developer/api/documentation/v1/objects/Weather.shtml

    Attribute names have been generated by converting ecobee property names from camelCase to snake_case.

    A getter property has been generated for each attribute.
    A setter property has been generated for each attribute whose value of READONLY is "no".

    An __init__ argument without a default value has been generated if the value of REQUIRED is "yes".
    An __init__ argument with a default value of None has been generated if the value of REQUIRED is "no".
   """
    __slots__ = ['_timestamp', '_weather_station', '_forecasts']

    attribute_name_map = {'timestamp': 'timestamp', 'weather_station': 'weatherStation',
                          'weatherStation': 'weather_station', 'forecasts': 'forecasts'}

    attribute_type_map = {'timestamp': 'six.text_type', 'weather_station': 'six.text_type',
                          'forecasts': 'List[WeatherForecast]'}

    def __init__(self, timestamp=None, weather_station=None, forecasts=None):
        """
        Construct a Weather instance
        """
        self._timestamp = timestamp
        self._weather_station = weather_station
        self._forecasts = forecasts

    @property
    def timestamp(self):
        """
        Gets the timestamp attribute of this Weather instance.

        :return: The value of the timestamp attribute of this Weather instance.
        :rtype: six.text_type
        """

        return self._timestamp

    @property
    def weather_station(self):
        """
        Gets the weather_station attribute of this Weather instance.

        :return: The value of the weather_station attribute of this Weather instance.
        :rtype: six.text_type
        """

        return self._weather_station

    @property
    def forecasts(self):
        """
        Gets the forecasts attribute of this Weather instance.

        :return: The value of the forecasts attribute of this Weather instance.
        :rtype: List[WeatherForecast]
        """

        return self._forecasts
